freeslot("sfx_tw")
freeslot("sfx_zo")
freeslot("sfx_rz")
freeslot("sfx_so")

//THE WORLD! STOP TIME!

local TimeStopped = false
local FlashTick = 0
local TSTimer = 0*TICRATE
local Damaged = {}
local GameTick = 0
local PlayerTS = true

COM_AddCommand("PlayerTimeStop", function(player, arg)
	if arg == "on"
		if PlayerTS == false
			PlayerTS = true
			print "Players are now stuck in timestop!"
		elseif PlayerTS == true
			print "Players never stood a chance against the power of The World before!"
		end
	elseif arg == "off"
		if PlayerTS == true
			PlayerTS = false
			print "Players can now move in stopped time!"
		elseif PlayerTS == false
			print "Players already knew the secret to The World!"
		end
	else
		print "It's on or off, Do you... Understand?"
	end
end)

addHook("PlayerThink", function(player)
	if player.tsstart == nil
		player.tsstart = 0
	end
	if player.tsstart > 0
		player.tsstart = player.tsstart - 1
	end
	if player.tsing == nil
		player.tsing = false
	end
	if player.excused == nil
		player.excused = false
	end
	if player.excusedtimer == nil
		player.excusedtimer = 0*TICRATE
	end
	if player.excusedtimer > 0
		player.excusedtimer = $ - 1
	end
	if player.tsmovement == nil
		player.tsmovement = false
	end
	if (player.cmd.buttons & BT_CUSTOM1) and (player.rings >= 100 or player.powers[pw_super]) and player.tsstart == 0 and player.tsing == false and not ((player.pflags & PF_STASIS) or (player.pflags & PF_FULLSTASIS) or P_PlayerInPain(player) or TSTimer > 0*TICRATE)
		player.tsstart = 120
		player.tsing = true
		S_StartSoundAtVolume(nil, sfx_so, 255)
	end
	if player.tsstart <= 100 and player.tsstart > 80
		player.pflags = $ + PF_FULLSTASIS
		if not P_IsObjectOnGround(player.mo)
			player.mo.state = S_PLAY_FALL
		elseif P_IsObjectOnGround(player.mo)
			player.mo.state = S_PLAY_STND
		end
	elseif player.tsstart < 80 and player.tsstart > 60
		player.mo.state = S_PLAY_SPINDASH
	elseif player.tsstart < 60 and player.tsstart > 40
		player.mo.state = S_PLAY_SPRING
		P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
	elseif player.tsstart < 40 and player.tsstart > 1
		player.mo.state = S_PLAY_FALL
		P_SetObjectMomZ(player.mo, 0*FRACUNIT, false)
	elseif player.tsstart == 1
		player.mo.state = S_PLAY_SUPER_TRANS1
		TSTimer = 10*TICRATE
		player.excused = true
		P_StartQuake(100*FRACUNIT, 15, {player.mo.x, player.mo.y, player.mo.z})
		if not player.powers[pw_super]
			P_GivePlayerRings(player, -100)
		end
	end
	if player.tsstart == 0
		player.tsing = false
	end
	if player.tsstart > 0 and player.tsstart <= 80
		if player.cmd.forwardmove == 0
			P_InstaThrust(player.mo, player.mo.angle, 0*FRACUNIT)
		elseif player.cmd.forwardmove < 0
			P_InstaThrust(player.mo, (player.mo.angle + ANGLE_180), skins[player.mo.skin].runspeed)
		elseif player.cmd.forwardmove > 0
			P_InstaThrust(player.mo, player.mo.angle, skins[player.mo.skin].runspeed)
		end
	end
	if (TimeStopped) and player.tsstart > 0
		player.tsstart = 0
		P_GivePlayerRings(player, -100)
	end
	if TSTimer == 0*TICRATE
		player.excused = false
		player.tsmovement = false
		player.excusedtimer = 0*TICRATE
	end
	if TSTimer > 0*TICRATE and not TimeStopped
		TimeStopped = true
	elseif TSTimer == 0*TICRATE and TimeStopped
		TimeStopped = false
		S_StartSoundAtVolume(nil, sfx_rz, 255)
	end
	if TimeStopped then
		if FlashTick > 0 then
			FlashTick = FlashTick - 1
			P_FlashPal(player, 2, 8)
		else
			P_FlashPal(player, 7, 8)
		end
	end
	if TimeStopped and not player.excused and PlayerTS == true
		player.mo.momx = 0
		player.mo.momy = 0
		player.mo.momz = 0
		player.mo.state = S_PLAY_GASP
		player.pflags = $ | PF_FULLSTASIS
	end
	if TimeStopped
	and not player.excused
	and not player.tsmovement
	and (player.cmd.buttons & BT_CUSTOM2)
	and ((player.rings >= 50) or (player.powers[pw_super]))
	and PlayerTS == true
		player.excused = true
		player.tsmovement = true
		player.excusedtimer = 4*TICRATE
		P_GivePlayerRings(player, -50)
	end
	if player.excusedtimer == 0*TICRATE	and player.tsmovement and player.excused
		player.excused = false
		player.tsmovement = false
	end
	if not TimeStopped and player.excusedtimer > 0*TICRATE
		player.excusedtimer = 0*TICRATE
	end
end)

addHook("ThinkFrame", function()
	if TSTimer > 0*TICRATE
		TSTimer = TSTimer - 1
	end
	for player in players.iterate()
		if player.tsstart == 80
			S_StartSoundAtVolume(nil, sfx_tw, 255)
		end
	end
	if TSTimer == 1*TICRATE
		S_StartSoundAtVolume(nil, sfx_zo, 255)
	end
end)

addHook("NetVars", function(network)
	TSTimer = network(TSTimer)
	TimeStopped = network(TimeStopped)
end)

addHook("MobjThinker", function(mo)
	if mo.valid then
		if mo.flags & (MF_ENEMY|MF_BOSS|MF_MISSILE) and TimeStopped then
			return true
		end
	end
end)

addHook("MapLoad", function()
	for player in players.iterate()
	TSTimer = 0*FRACUNIT
	TimeStopped = false
	player.tsstart = 0
	end
end)

local function Thinker(mo)
	if mo.valid then
		if TimeStopped then
			return true
		end
	end
end

for i,v in pairs(TS_Inclusion) do
	TS_NewHook(v, Thinker)
end

for i,v in pairs(TS_Flickies) do
	TS_NewHook(v, Thinker)
end

local function timer(v, player)
	if player.mo and player.mo.valid
		if (maptol & TOL_NIGHTS) then -- Prevents the code from running in a Nights special stage
			return
		end
		
		if TimeStopped
			v.drawString(150, 165, (G_TicsToSeconds(TSTimer)))
		end
	end
end
hud.add(timer, "game")

addHook("MobjDeath", function(target, inflictor, source, damagetype)
	if source and source.valid
	and source.player and source.player.mo.valid
	and (target.flags & MF_ENEMY)
	and not (target.flags & MF_BOSS)
	and not TimeStopped
		P_GivePlayerRings(source.player, 10)
	end
end)

addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if source and source.valid
	and source.player and source.player.mo.valid
	and ((target.flags & MF_BOSS) or (target.type == MT_PLAYER))
	and not TimeStopped
		P_GivePlayerRings(source.player, 15)
	end
end)

local function Collide(target,inflictor)
	if TimeStopped 
	and inflictor.valid and target.valid 
	and (target.flags & (MF_ENEMY|MF_BOSS)) 
	and inflictor.type == MT_PLAYER 
	and (inflictor.state == S_PLAY_JUMP or inflictor.state == S_PLAY_FALL or inflictor.state == S_PLAY_ROLL) 
	and target.z <= inflictor.z + inflictor.height
	and target.z + target.height >= inflictor.z then
		P_DamageMobj(target, source, source)
		target.flags2 = $ & ~MF2_FRET
		P_SetObjectMomZ(inflictor, inflictor.momz - inflictor.momz*2, false)
	end
	if inflictor.player and inflictor.player.homing > 0 then
		inflictor.player.homing = 0
	end
	return
end

addHook("MobjCollide", Collide)
addHook("MobjMoveCollide", Collide)